﻿using System;
using System.Text;
using System.Collections.Generic;
using Kona.Infrastructure;
using System.Linq.Expressions;
using System.Data.Common;
using System.Linq;

namespace Kona.SimpleSqlRepository {

 

        public static class DeliveryMethodTable{
            public const string TABLE_NAME=@"[dbo].[DeliveryMethod]";
            public const string COLUMN_LIST=@"[dbo].[DeliveryMethod].[DeliveryMethodID],[dbo].[DeliveryMethod].[Description]";
 
                public static int ReadDeliveryMethodID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["DeliveryMethodID"].ToString(), out result);
                                return result;
            }
                public static string ReadDescription(DbDataReader rdr){
                string result;
                                result= rdr["Description"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string DeliveryMethodID="@DeliveryMethodID";
                    public static string Description="@Description";
                }    
            
            public struct Columns{
                    public static string DeliveryMethodID="DeliveryMethodID";
                    public static string Description="Description";
                } 
            public struct ColumnsQualified{
                    public static string DeliveryMethodID="[dbo].[DeliveryMethod].[DeliveryMethodID]";
                    public static string Description="[dbo].[DeliveryMethod].[Description]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("DeliveryMethodID","[dbo].[DeliveryMethod].[DeliveryMethodID]");
                            _qualifiedColumns.Add("Description","[dbo].[DeliveryMethod].[Description]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[DeliveryMethod](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[DeliveryMethod]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[DeliveryMethod]");
                return sql;
            }
        }
         

        public static class TaxRatesTable{
            public const string TABLE_NAME=@"[dbo].[TaxRates]";
            public const string COLUMN_LIST=@"[dbo].[TaxRates].[Country],[dbo].[TaxRates].[PostalCode],[dbo].[TaxRates].[Rate],[dbo].[TaxRates].[Region],[dbo].[TaxRates].[TaxRateID]";
 
                public static string ReadCountry(DbDataReader rdr){
                string result;
                                result= rdr["Country"].ToString();
                                return result;
            }
                public static string ReadPostalCode(DbDataReader rdr){
                string result;
                                result= rdr["PostalCode"].ToString();
                                return result;
            }
                public static decimal ReadRate(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["Rate"].ToString(), out result);
                                return result;
            }
                public static string ReadRegion(DbDataReader rdr){
                string result;
                                result= rdr["Region"].ToString();
                                return result;
            }
                public static int ReadTaxRateID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["TaxRateID"].ToString(), out result);
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Country="@Country";
                    public static string PostalCode="@PostalCode";
                    public static string Rate="@Rate";
                    public static string Region="@Region";
                    public static string TaxRateID="@TaxRateID";
                }    
            
            public struct Columns{
                    public static string Country="Country";
                    public static string PostalCode="PostalCode";
                    public static string Rate="Rate";
                    public static string Region="Region";
                    public static string TaxRateID="TaxRateID";
                } 
            public struct ColumnsQualified{
                    public static string Country="[dbo].[TaxRates].[Country]";
                    public static string PostalCode="[dbo].[TaxRates].[PostalCode]";
                    public static string Rate="[dbo].[TaxRates].[Rate]";
                    public static string Region="[dbo].[TaxRates].[Region]";
                    public static string TaxRateID="[dbo].[TaxRates].[TaxRateID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Country","[dbo].[TaxRates].[Country]");
                            _qualifiedColumns.Add("PostalCode","[dbo].[TaxRates].[PostalCode]");
                            _qualifiedColumns.Add("Rate","[dbo].[TaxRates].[Rate]");
                            _qualifiedColumns.Add("Region","[dbo].[TaxRates].[Region]");
                            _qualifiedColumns.Add("TaxRateID","[dbo].[TaxRates].[TaxRateID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[TaxRates](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[TaxRates]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[TaxRates]");
                return sql;
            }
        }
         

        public static class OrderStatusTable{
            public const string TABLE_NAME=@"[dbo].[OrderStatus]";
            public const string COLUMN_LIST=@"[dbo].[OrderStatus].[Description],[dbo].[OrderStatus].[OrderStatusID]";
 
                public static string ReadDescription(DbDataReader rdr){
                string result;
                                result= rdr["Description"].ToString();
                                return result;
            }
                public static int ReadOrderStatusID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["OrderStatusID"].ToString(), out result);
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Description="@Description";
                    public static string OrderStatusID="@OrderStatusID";
                }    
            
            public struct Columns{
                    public static string Description="Description";
                    public static string OrderStatusID="OrderStatusID";
                } 
            public struct ColumnsQualified{
                    public static string Description="[dbo].[OrderStatus].[Description]";
                    public static string OrderStatusID="[dbo].[OrderStatus].[OrderStatusID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Description","[dbo].[OrderStatus].[Description]");
                            _qualifiedColumns.Add("OrderStatusID","[dbo].[OrderStatus].[OrderStatusID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[OrderStatus](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[OrderStatus]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[OrderStatus]");
                return sql;
            }
        }
         

        public static class PageStatusTable{
            public const string TABLE_NAME=@"[dbo].[PageStatus]";
            public const string COLUMN_LIST=@"[dbo].[PageStatus].[Description],[dbo].[PageStatus].[IsPublished],[dbo].[PageStatus].[PageStatusID]";
 
                public static string ReadDescription(DbDataReader rdr){
                string result;
                                result= rdr["Description"].ToString();
                                return result;
            }
                public static bool ReadIsPublished(DbDataReader rdr){
                bool result;
                                bool.TryParse(rdr["IsPublished"].ToString(), out result);
                                return result;
            }
                public static int ReadPageStatusID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["PageStatusID"].ToString(), out result);
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Description="@Description";
                    public static string IsPublished="@IsPublished";
                    public static string PageStatusID="@PageStatusID";
                }    
            
            public struct Columns{
                    public static string Description="Description";
                    public static string IsPublished="IsPublished";
                    public static string PageStatusID="PageStatusID";
                } 
            public struct ColumnsQualified{
                    public static string Description="[dbo].[PageStatus].[Description]";
                    public static string IsPublished="[dbo].[PageStatus].[IsPublished]";
                    public static string PageStatusID="[dbo].[PageStatus].[PageStatusID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Description","[dbo].[PageStatus].[Description]");
                            _qualifiedColumns.Add("IsPublished","[dbo].[PageStatus].[IsPublished]");
                            _qualifiedColumns.Add("PageStatusID","[dbo].[PageStatus].[PageStatusID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[PageStatus](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[PageStatus]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[PageStatus]");
                return sql;
            }
        }
         

        public static class CustomerBehaviorsTable{
            public const string TABLE_NAME=@"[dbo].[CustomerBehaviors]";
            public const string COLUMN_LIST=@"[dbo].[CustomerBehaviors].[Description],[dbo].[CustomerBehaviors].[UserBehaviorID]";
 
                public static string ReadDescription(DbDataReader rdr){
                string result;
                                result= rdr["Description"].ToString();
                                return result;
            }
                public static int ReadUserBehaviorID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["UserBehaviorID"].ToString(), out result);
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Description="@Description";
                    public static string UserBehaviorID="@UserBehaviorID";
                }    
            
            public struct Columns{
                    public static string Description="Description";
                    public static string UserBehaviorID="UserBehaviorID";
                } 
            public struct ColumnsQualified{
                    public static string Description="[dbo].[CustomerBehaviors].[Description]";
                    public static string UserBehaviorID="[dbo].[CustomerBehaviors].[UserBehaviorID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Description","[dbo].[CustomerBehaviors].[Description]");
                            _qualifiedColumns.Add("UserBehaviorID","[dbo].[CustomerBehaviors].[UserBehaviorID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[CustomerBehaviors](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[CustomerBehaviors]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[CustomerBehaviors]");
                return sql;
            }
        }
         

        public static class CustomersTable{
            public const string TABLE_NAME=@"[dbo].[Customers]";
            public const string COLUMN_LIST=@"[dbo].[Customers].[Email],[dbo].[Customers].[First],[dbo].[Customers].[LanguageCode],[dbo].[Customers].[Last],[dbo].[Customers].[UserName]";
 
                public static string ReadEmail(DbDataReader rdr){
                string result;
                                result= rdr["Email"].ToString();
                                return result;
            }
                public static string ReadFirst(DbDataReader rdr){
                string result;
                                result= rdr["First"].ToString();
                                return result;
            }
                public static string ReadLanguageCode(DbDataReader rdr){
                string result;
                                result= rdr["LanguageCode"].ToString();
                                return result;
            }
                public static string ReadLast(DbDataReader rdr){
                string result;
                                result= rdr["Last"].ToString();
                                return result;
            }
                public static string ReadUserName(DbDataReader rdr){
                string result;
                                result= rdr["UserName"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Email="@Email";
                    public static string First="@First";
                    public static string LanguageCode="@LanguageCode";
                    public static string Last="@Last";
                    public static string UserName="@UserName";
                }    
            
            public struct Columns{
                    public static string Email="Email";
                    public static string First="First";
                    public static string LanguageCode="LanguageCode";
                    public static string Last="Last";
                    public static string UserName="UserName";
                } 
            public struct ColumnsQualified{
                    public static string Email="[dbo].[Customers].[Email]";
                    public static string First="[dbo].[Customers].[First]";
                    public static string LanguageCode="[dbo].[Customers].[LanguageCode]";
                    public static string Last="[dbo].[Customers].[Last]";
                    public static string UserName="[dbo].[Customers].[UserName]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Email","[dbo].[Customers].[Email]");
                            _qualifiedColumns.Add("First","[dbo].[Customers].[First]");
                            _qualifiedColumns.Add("LanguageCode","[dbo].[Customers].[LanguageCode]");
                            _qualifiedColumns.Add("Last","[dbo].[Customers].[Last]");
                            _qualifiedColumns.Add("UserName","[dbo].[Customers].[UserName]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Customers](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Customers]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Customers]");
                return sql;
            }
        }
         

        public static class AddressesTable{
            public const string TABLE_NAME=@"[dbo].[Addresses]";
            public const string COLUMN_LIST=@"[dbo].[Addresses].[AddressID],[dbo].[Addresses].[City],[dbo].[Addresses].[Country],[dbo].[Addresses].[Email],[dbo].[Addresses].[FirstName],[dbo].[Addresses].[IsDefault],[dbo].[Addresses].[LastName],[dbo].[Addresses].[Latitude],[dbo].[Addresses].[Longitude],[dbo].[Addresses].[StateOrProvince],[dbo].[Addresses].[Street1],[dbo].[Addresses].[Street2],[dbo].[Addresses].[UserName],[dbo].[Addresses].[Zip]";
 
                public static int ReadAddressID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["AddressID"].ToString(), out result);
                                return result;
            }
                public static string ReadCity(DbDataReader rdr){
                string result;
                                result= rdr["City"].ToString();
                                return result;
            }
                public static string ReadCountry(DbDataReader rdr){
                string result;
                                result= rdr["Country"].ToString();
                                return result;
            }
                public static string ReadEmail(DbDataReader rdr){
                string result;
                                result= rdr["Email"].ToString();
                                return result;
            }
                public static string ReadFirstName(DbDataReader rdr){
                string result;
                                result= rdr["FirstName"].ToString();
                                return result;
            }
                public static bool ReadIsDefault(DbDataReader rdr){
                bool result;
                                bool.TryParse(rdr["IsDefault"].ToString(), out result);
                                return result;
            }
                public static string ReadLastName(DbDataReader rdr){
                string result;
                                result= rdr["LastName"].ToString();
                                return result;
            }
                public static string ReadLatitude(DbDataReader rdr){
                string result;
                                result= rdr["Latitude"].ToString();
                                return result;
            }
                public static string ReadLongitude(DbDataReader rdr){
                string result;
                                result= rdr["Longitude"].ToString();
                                return result;
            }
                public static string ReadStateOrProvince(DbDataReader rdr){
                string result;
                                result= rdr["StateOrProvince"].ToString();
                                return result;
            }
                public static string ReadStreet1(DbDataReader rdr){
                string result;
                                result= rdr["Street1"].ToString();
                                return result;
            }
                public static string ReadStreet2(DbDataReader rdr){
                string result;
                                result= rdr["Street2"].ToString();
                                return result;
            }
                public static string ReadUserName(DbDataReader rdr){
                string result;
                                result= rdr["UserName"].ToString();
                                return result;
            }
                public static string ReadZip(DbDataReader rdr){
                string result;
                                result= rdr["Zip"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string AddressID="@AddressID";
                    public static string City="@City";
                    public static string Country="@Country";
                    public static string Email="@Email";
                    public static string FirstName="@FirstName";
                    public static string IsDefault="@IsDefault";
                    public static string LastName="@LastName";
                    public static string Latitude="@Latitude";
                    public static string Longitude="@Longitude";
                    public static string StateOrProvince="@StateOrProvince";
                    public static string Street1="@Street1";
                    public static string Street2="@Street2";
                    public static string UserName="@UserName";
                    public static string Zip="@Zip";
                }    
            
            public struct Columns{
                    public static string AddressID="AddressID";
                    public static string City="City";
                    public static string Country="Country";
                    public static string Email="Email";
                    public static string FirstName="FirstName";
                    public static string IsDefault="IsDefault";
                    public static string LastName="LastName";
                    public static string Latitude="Latitude";
                    public static string Longitude="Longitude";
                    public static string StateOrProvince="StateOrProvince";
                    public static string Street1="Street1";
                    public static string Street2="Street2";
                    public static string UserName="UserName";
                    public static string Zip="Zip";
                } 
            public struct ColumnsQualified{
                    public static string AddressID="[dbo].[Addresses].[AddressID]";
                    public static string City="[dbo].[Addresses].[City]";
                    public static string Country="[dbo].[Addresses].[Country]";
                    public static string Email="[dbo].[Addresses].[Email]";
                    public static string FirstName="[dbo].[Addresses].[FirstName]";
                    public static string IsDefault="[dbo].[Addresses].[IsDefault]";
                    public static string LastName="[dbo].[Addresses].[LastName]";
                    public static string Latitude="[dbo].[Addresses].[Latitude]";
                    public static string Longitude="[dbo].[Addresses].[Longitude]";
                    public static string StateOrProvince="[dbo].[Addresses].[StateOrProvince]";
                    public static string Street1="[dbo].[Addresses].[Street1]";
                    public static string Street2="[dbo].[Addresses].[Street2]";
                    public static string UserName="[dbo].[Addresses].[UserName]";
                    public static string Zip="[dbo].[Addresses].[Zip]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("AddressID","[dbo].[Addresses].[AddressID]");
                            _qualifiedColumns.Add("City","[dbo].[Addresses].[City]");
                            _qualifiedColumns.Add("Country","[dbo].[Addresses].[Country]");
                            _qualifiedColumns.Add("Email","[dbo].[Addresses].[Email]");
                            _qualifiedColumns.Add("FirstName","[dbo].[Addresses].[FirstName]");
                            _qualifiedColumns.Add("IsDefault","[dbo].[Addresses].[IsDefault]");
                            _qualifiedColumns.Add("LastName","[dbo].[Addresses].[LastName]");
                            _qualifiedColumns.Add("Latitude","[dbo].[Addresses].[Latitude]");
                            _qualifiedColumns.Add("Longitude","[dbo].[Addresses].[Longitude]");
                            _qualifiedColumns.Add("StateOrProvince","[dbo].[Addresses].[StateOrProvince]");
                            _qualifiedColumns.Add("Street1","[dbo].[Addresses].[Street1]");
                            _qualifiedColumns.Add("Street2","[dbo].[Addresses].[Street2]");
                            _qualifiedColumns.Add("UserName","[dbo].[Addresses].[UserName]");
                            _qualifiedColumns.Add("Zip","[dbo].[Addresses].[Zip]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Addresses](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Addresses]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Addresses]");
                return sql;
            }
        }
         

        public static class CategoryLocalizedTable{
            public const string TABLE_NAME=@"[dbo].[CategoryLocalized]";
            public const string COLUMN_LIST=@"[dbo].[CategoryLocalized].[CategoryID],[dbo].[CategoryLocalized].[CategoryNameID],[dbo].[CategoryLocalized].[DefaultImageFile],[dbo].[CategoryLocalized].[Description],[dbo].[CategoryLocalized].[LanguageCode],[dbo].[CategoryLocalized].[Name]";
 
                public static int ReadCategoryID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["CategoryID"].ToString(), out result);
                                return result;
            }
                public static int ReadCategoryNameID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["CategoryNameID"].ToString(), out result);
                                return result;
            }
                public static string ReadDefaultImageFile(DbDataReader rdr){
                string result;
                                result= rdr["DefaultImageFile"].ToString();
                                return result;
            }
                public static string ReadDescription(DbDataReader rdr){
                string result;
                                result= rdr["Description"].ToString();
                                return result;
            }
                public static string ReadLanguageCode(DbDataReader rdr){
                string result;
                                result= rdr["LanguageCode"].ToString();
                                return result;
            }
                public static string ReadName(DbDataReader rdr){
                string result;
                                result= rdr["Name"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string CategoryID="@CategoryID";
                    public static string CategoryNameID="@CategoryNameID";
                    public static string DefaultImageFile="@DefaultImageFile";
                    public static string Description="@Description";
                    public static string LanguageCode="@LanguageCode";
                    public static string Name="@Name";
                }    
            
            public struct Columns{
                    public static string CategoryID="CategoryID";
                    public static string CategoryNameID="CategoryNameID";
                    public static string DefaultImageFile="DefaultImageFile";
                    public static string Description="Description";
                    public static string LanguageCode="LanguageCode";
                    public static string Name="Name";
                } 
            public struct ColumnsQualified{
                    public static string CategoryID="[dbo].[CategoryLocalized].[CategoryID]";
                    public static string CategoryNameID="[dbo].[CategoryLocalized].[CategoryNameID]";
                    public static string DefaultImageFile="[dbo].[CategoryLocalized].[DefaultImageFile]";
                    public static string Description="[dbo].[CategoryLocalized].[Description]";
                    public static string LanguageCode="[dbo].[CategoryLocalized].[LanguageCode]";
                    public static string Name="[dbo].[CategoryLocalized].[Name]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("CategoryID","[dbo].[CategoryLocalized].[CategoryID]");
                            _qualifiedColumns.Add("CategoryNameID","[dbo].[CategoryLocalized].[CategoryNameID]");
                            _qualifiedColumns.Add("DefaultImageFile","[dbo].[CategoryLocalized].[DefaultImageFile]");
                            _qualifiedColumns.Add("Description","[dbo].[CategoryLocalized].[Description]");
                            _qualifiedColumns.Add("LanguageCode","[dbo].[CategoryLocalized].[LanguageCode]");
                            _qualifiedColumns.Add("Name","[dbo].[CategoryLocalized].[Name]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[CategoryLocalized](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[CategoryLocalized]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[CategoryLocalized]");
                return sql;
            }
        }
         

        public static class Categories_ProductsTable{
            public const string TABLE_NAME=@"[dbo].[Categories_Products]";
            public const string COLUMN_LIST=@"[dbo].[Categories_Products].[CategoryID],[dbo].[Categories_Products].[SKU]";
 
                public static int ReadCategoryID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["CategoryID"].ToString(), out result);
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string CategoryID="@CategoryID";
                    public static string SKU="@SKU";
                }    
            
            public struct Columns{
                    public static string CategoryID="CategoryID";
                    public static string SKU="SKU";
                } 
            public struct ColumnsQualified{
                    public static string CategoryID="[dbo].[Categories_Products].[CategoryID]";
                    public static string SKU="[dbo].[Categories_Products].[SKU]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("CategoryID","[dbo].[Categories_Products].[CategoryID]");
                            _qualifiedColumns.Add("SKU","[dbo].[Categories_Products].[SKU]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Categories_Products](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Categories_Products]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Categories_Products]");
                return sql;
            }
        }
         

        public static class CategoryImagesTable{
            public const string TABLE_NAME=@"[dbo].[CategoryImages]";
            public const string COLUMN_LIST=@"[dbo].[CategoryImages].[CategoryID],[dbo].[CategoryImages].[CategoryImageID],[dbo].[CategoryImages].[FullImageUrl],[dbo].[CategoryImages].[ThumbUrl]";
 
                public static int ReadCategoryID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["CategoryID"].ToString(), out result);
                                return result;
            }
                public static int ReadCategoryImageID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["CategoryImageID"].ToString(), out result);
                                return result;
            }
                public static string ReadFullImageUrl(DbDataReader rdr){
                string result;
                                result= rdr["FullImageUrl"].ToString();
                                return result;
            }
                public static string ReadThumbUrl(DbDataReader rdr){
                string result;
                                result= rdr["ThumbUrl"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string CategoryID="@CategoryID";
                    public static string CategoryImageID="@CategoryImageID";
                    public static string FullImageUrl="@FullImageUrl";
                    public static string ThumbUrl="@ThumbUrl";
                }    
            
            public struct Columns{
                    public static string CategoryID="CategoryID";
                    public static string CategoryImageID="CategoryImageID";
                    public static string FullImageUrl="FullImageUrl";
                    public static string ThumbUrl="ThumbUrl";
                } 
            public struct ColumnsQualified{
                    public static string CategoryID="[dbo].[CategoryImages].[CategoryID]";
                    public static string CategoryImageID="[dbo].[CategoryImages].[CategoryImageID]";
                    public static string FullImageUrl="[dbo].[CategoryImages].[FullImageUrl]";
                    public static string ThumbUrl="[dbo].[CategoryImages].[ThumbUrl]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("CategoryID","[dbo].[CategoryImages].[CategoryID]");
                            _qualifiedColumns.Add("CategoryImageID","[dbo].[CategoryImages].[CategoryImageID]");
                            _qualifiedColumns.Add("FullImageUrl","[dbo].[CategoryImages].[FullImageUrl]");
                            _qualifiedColumns.Add("ThumbUrl","[dbo].[CategoryImages].[ThumbUrl]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[CategoryImages](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[CategoryImages]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[CategoryImages]");
                return sql;
            }
        }
         

        public static class Products_CrossSellTable{
            public const string TABLE_NAME=@"[dbo].[Products_CrossSell]";
            public const string COLUMN_LIST=@"[dbo].[Products_CrossSell].[CrossSKU],[dbo].[Products_CrossSell].[SKU]";
 
                public static string ReadCrossSKU(DbDataReader rdr){
                string result;
                                result= rdr["CrossSKU"].ToString();
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string CrossSKU="@CrossSKU";
                    public static string SKU="@SKU";
                }    
            
            public struct Columns{
                    public static string CrossSKU="CrossSKU";
                    public static string SKU="SKU";
                } 
            public struct ColumnsQualified{
                    public static string CrossSKU="[dbo].[Products_CrossSell].[CrossSKU]";
                    public static string SKU="[dbo].[Products_CrossSell].[SKU]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("CrossSKU","[dbo].[Products_CrossSell].[CrossSKU]");
                            _qualifiedColumns.Add("SKU","[dbo].[Products_CrossSell].[SKU]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Products_CrossSell](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Products_CrossSell]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Products_CrossSell]");
                return sql;
            }
        }
         

        public static class Products_RelatedTable{
            public const string TABLE_NAME=@"[dbo].[Products_Related]";
            public const string COLUMN_LIST=@"[dbo].[Products_Related].[RelatedSKU],[dbo].[Products_Related].[SKU]";
 
                public static string ReadRelatedSKU(DbDataReader rdr){
                string result;
                                result= rdr["RelatedSKU"].ToString();
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string RelatedSKU="@RelatedSKU";
                    public static string SKU="@SKU";
                }    
            
            public struct Columns{
                    public static string RelatedSKU="RelatedSKU";
                    public static string SKU="SKU";
                } 
            public struct ColumnsQualified{
                    public static string RelatedSKU="[dbo].[Products_Related].[RelatedSKU]";
                    public static string SKU="[dbo].[Products_Related].[SKU]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("RelatedSKU","[dbo].[Products_Related].[RelatedSKU]");
                            _qualifiedColumns.Add("SKU","[dbo].[Products_Related].[SKU]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Products_Related](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Products_Related]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Products_Related]");
                return sql;
            }
        }
         

        public static class ProductImagesTable{
            public const string TABLE_NAME=@"[dbo].[ProductImages]";
            public const string COLUMN_LIST=@"[dbo].[ProductImages].[FullImageUrl],[dbo].[ProductImages].[ProductImageID],[dbo].[ProductImages].[SKU],[dbo].[ProductImages].[ThumbUrl]";
 
                public static string ReadFullImageUrl(DbDataReader rdr){
                string result;
                                result= rdr["FullImageUrl"].ToString();
                                return result;
            }
                public static int ReadProductImageID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["ProductImageID"].ToString(), out result);
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
                public static string ReadThumbUrl(DbDataReader rdr){
                string result;
                                result= rdr["ThumbUrl"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string FullImageUrl="@FullImageUrl";
                    public static string ProductImageID="@ProductImageID";
                    public static string SKU="@SKU";
                    public static string ThumbUrl="@ThumbUrl";
                }    
            
            public struct Columns{
                    public static string FullImageUrl="FullImageUrl";
                    public static string ProductImageID="ProductImageID";
                    public static string SKU="SKU";
                    public static string ThumbUrl="ThumbUrl";
                } 
            public struct ColumnsQualified{
                    public static string FullImageUrl="[dbo].[ProductImages].[FullImageUrl]";
                    public static string ProductImageID="[dbo].[ProductImages].[ProductImageID]";
                    public static string SKU="[dbo].[ProductImages].[SKU]";
                    public static string ThumbUrl="[dbo].[ProductImages].[ThumbUrl]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("FullImageUrl","[dbo].[ProductImages].[FullImageUrl]");
                            _qualifiedColumns.Add("ProductImageID","[dbo].[ProductImages].[ProductImageID]");
                            _qualifiedColumns.Add("SKU","[dbo].[ProductImages].[SKU]");
                            _qualifiedColumns.Add("ThumbUrl","[dbo].[ProductImages].[ThumbUrl]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[ProductImages](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[ProductImages]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[ProductImages]");
                return sql;
            }
        }
         

        public static class ProductDescriptorsTable{
            public const string TABLE_NAME=@"[dbo].[ProductDescriptors]";
            public const string COLUMN_LIST=@"[dbo].[ProductDescriptors].[Body],[dbo].[ProductDescriptors].[DescriptorID],[dbo].[ProductDescriptors].[IsDefault],[dbo].[ProductDescriptors].[LanguageCode],[dbo].[ProductDescriptors].[SKU],[dbo].[ProductDescriptors].[Title]";
 
                public static string ReadBody(DbDataReader rdr){
                string result;
                                result= rdr["Body"].ToString();
                                return result;
            }
                public static int ReadDescriptorID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["DescriptorID"].ToString(), out result);
                                return result;
            }
                public static bool ReadIsDefault(DbDataReader rdr){
                bool result;
                                bool.TryParse(rdr["IsDefault"].ToString(), out result);
                                return result;
            }
                public static string ReadLanguageCode(DbDataReader rdr){
                string result;
                                result= rdr["LanguageCode"].ToString();
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
                public static string ReadTitle(DbDataReader rdr){
                string result;
                                result= rdr["Title"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Body="@Body";
                    public static string DescriptorID="@DescriptorID";
                    public static string IsDefault="@IsDefault";
                    public static string LanguageCode="@LanguageCode";
                    public static string SKU="@SKU";
                    public static string Title="@Title";
                }    
            
            public struct Columns{
                    public static string Body="Body";
                    public static string DescriptorID="DescriptorID";
                    public static string IsDefault="IsDefault";
                    public static string LanguageCode="LanguageCode";
                    public static string SKU="SKU";
                    public static string Title="Title";
                } 
            public struct ColumnsQualified{
                    public static string Body="[dbo].[ProductDescriptors].[Body]";
                    public static string DescriptorID="[dbo].[ProductDescriptors].[DescriptorID]";
                    public static string IsDefault="[dbo].[ProductDescriptors].[IsDefault]";
                    public static string LanguageCode="[dbo].[ProductDescriptors].[LanguageCode]";
                    public static string SKU="[dbo].[ProductDescriptors].[SKU]";
                    public static string Title="[dbo].[ProductDescriptors].[Title]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Body","[dbo].[ProductDescriptors].[Body]");
                            _qualifiedColumns.Add("DescriptorID","[dbo].[ProductDescriptors].[DescriptorID]");
                            _qualifiedColumns.Add("IsDefault","[dbo].[ProductDescriptors].[IsDefault]");
                            _qualifiedColumns.Add("LanguageCode","[dbo].[ProductDescriptors].[LanguageCode]");
                            _qualifiedColumns.Add("SKU","[dbo].[ProductDescriptors].[SKU]");
                            _qualifiedColumns.Add("Title","[dbo].[ProductDescriptors].[Title]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[ProductDescriptors](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[ProductDescriptors]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[ProductDescriptors]");
                return sql;
            }
        }
         

        public static class InventoryRecordsTable{
            public const string TABLE_NAME=@"[dbo].[InventoryRecords]";
            public const string COLUMN_LIST=@"[dbo].[InventoryRecords].[DateEntered],[dbo].[InventoryRecords].[Increment],[dbo].[InventoryRecords].[InventoryRecordID],[dbo].[InventoryRecords].[Notes],[dbo].[InventoryRecords].[SKU]";
 
                public static DateTime ReadDateEntered(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["DateEntered"].ToString(), out result);
                                return result;
            }
                public static int ReadIncrement(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["Increment"].ToString(), out result);
                                return result;
            }
                public static int ReadInventoryRecordID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["InventoryRecordID"].ToString(), out result);
                                return result;
            }
                public static string ReadNotes(DbDataReader rdr){
                string result;
                                result= rdr["Notes"].ToString();
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string DateEntered="@DateEntered";
                    public static string Increment="@Increment";
                    public static string InventoryRecordID="@InventoryRecordID";
                    public static string Notes="@Notes";
                    public static string SKU="@SKU";
                }    
            
            public struct Columns{
                    public static string DateEntered="DateEntered";
                    public static string Increment="Increment";
                    public static string InventoryRecordID="InventoryRecordID";
                    public static string Notes="Notes";
                    public static string SKU="SKU";
                } 
            public struct ColumnsQualified{
                    public static string DateEntered="[dbo].[InventoryRecords].[DateEntered]";
                    public static string Increment="[dbo].[InventoryRecords].[Increment]";
                    public static string InventoryRecordID="[dbo].[InventoryRecords].[InventoryRecordID]";
                    public static string Notes="[dbo].[InventoryRecords].[Notes]";
                    public static string SKU="[dbo].[InventoryRecords].[SKU]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("DateEntered","[dbo].[InventoryRecords].[DateEntered]");
                            _qualifiedColumns.Add("Increment","[dbo].[InventoryRecords].[Increment]");
                            _qualifiedColumns.Add("InventoryRecordID","[dbo].[InventoryRecords].[InventoryRecordID]");
                            _qualifiedColumns.Add("Notes","[dbo].[InventoryRecords].[Notes]");
                            _qualifiedColumns.Add("SKU","[dbo].[InventoryRecords].[SKU]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[InventoryRecords](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[InventoryRecords]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[InventoryRecords]");
                return sql;
            }
        }
         

        public static class TransactionsTable{
            public const string TABLE_NAME=@"[dbo].[Transactions]";
            public const string COLUMN_LIST=@"[dbo].[Transactions].[Amount],[dbo].[Transactions].[AuthorizationCode],[dbo].[Transactions].[Notes],[dbo].[Transactions].[OrderID],[dbo].[Transactions].[Processor],[dbo].[Transactions].[TransactionDate],[dbo].[Transactions].[TransactionID]";
 
                public static decimal ReadAmount(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["Amount"].ToString(), out result);
                                return result;
            }
                public static string ReadAuthorizationCode(DbDataReader rdr){
                string result;
                                result= rdr["AuthorizationCode"].ToString();
                                return result;
            }
                public static string ReadNotes(DbDataReader rdr){
                string result;
                                result= rdr["Notes"].ToString();
                                return result;
            }
                public static Guid ReadOrderID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["OrderID"];
                                return result;
            }
                public static string ReadProcessor(DbDataReader rdr){
                string result;
                                result= rdr["Processor"].ToString();
                                return result;
            }
                public static DateTime ReadTransactionDate(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["TransactionDate"].ToString(), out result);
                                return result;
            }
                public static Guid ReadTransactionID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["TransactionID"];
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Amount="@Amount";
                    public static string AuthorizationCode="@AuthorizationCode";
                    public static string Notes="@Notes";
                    public static string OrderID="@OrderID";
                    public static string Processor="@Processor";
                    public static string TransactionDate="@TransactionDate";
                    public static string TransactionID="@TransactionID";
                }    
            
            public struct Columns{
                    public static string Amount="Amount";
                    public static string AuthorizationCode="AuthorizationCode";
                    public static string Notes="Notes";
                    public static string OrderID="OrderID";
                    public static string Processor="Processor";
                    public static string TransactionDate="TransactionDate";
                    public static string TransactionID="TransactionID";
                } 
            public struct ColumnsQualified{
                    public static string Amount="[dbo].[Transactions].[Amount]";
                    public static string AuthorizationCode="[dbo].[Transactions].[AuthorizationCode]";
                    public static string Notes="[dbo].[Transactions].[Notes]";
                    public static string OrderID="[dbo].[Transactions].[OrderID]";
                    public static string Processor="[dbo].[Transactions].[Processor]";
                    public static string TransactionDate="[dbo].[Transactions].[TransactionDate]";
                    public static string TransactionID="[dbo].[Transactions].[TransactionID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Amount","[dbo].[Transactions].[Amount]");
                            _qualifiedColumns.Add("AuthorizationCode","[dbo].[Transactions].[AuthorizationCode]");
                            _qualifiedColumns.Add("Notes","[dbo].[Transactions].[Notes]");
                            _qualifiedColumns.Add("OrderID","[dbo].[Transactions].[OrderID]");
                            _qualifiedColumns.Add("Processor","[dbo].[Transactions].[Processor]");
                            _qualifiedColumns.Add("TransactionDate","[dbo].[Transactions].[TransactionDate]");
                            _qualifiedColumns.Add("TransactionID","[dbo].[Transactions].[TransactionID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Transactions](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Transactions]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Transactions]");
                return sql;
            }
        }
         

        public static class Widgets_ProductsTable{
            public const string TABLE_NAME=@"[dbo].[Widgets_Products]";
            public const string COLUMN_LIST=@"[dbo].[Widgets_Products].[listOrder],[dbo].[Widgets_Products].[SKU],[dbo].[Widgets_Products].[WidgetID]";
 
                public static int ReadlistOrder(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["listOrder"].ToString(), out result);
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
                public static Guid ReadWidgetID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["WidgetID"];
                                return result;
            }
        
            
            public struct Parameters{
                    public static string listOrder="@listOrder";
                    public static string SKU="@SKU";
                    public static string WidgetID="@WidgetID";
                }    
            
            public struct Columns{
                    public static string listOrder="listOrder";
                    public static string SKU="SKU";
                    public static string WidgetID="WidgetID";
                } 
            public struct ColumnsQualified{
                    public static string listOrder="[dbo].[Widgets_Products].[listOrder]";
                    public static string SKU="[dbo].[Widgets_Products].[SKU]";
                    public static string WidgetID="[dbo].[Widgets_Products].[WidgetID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("listOrder","[dbo].[Widgets_Products].[listOrder]");
                            _qualifiedColumns.Add("SKU","[dbo].[Widgets_Products].[SKU]");
                            _qualifiedColumns.Add("WidgetID","[dbo].[Widgets_Products].[WidgetID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Widgets_Products](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Widgets_Products]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Widgets_Products]");
                return sql;
            }
        }
         

        public static class CustomerEventsTable{
            public const string TABLE_NAME=@"[dbo].[CustomerEvents]";
            public const string COLUMN_LIST=@"[dbo].[CustomerEvents].[CategoryID],[dbo].[CustomerEvents].[EventDate],[dbo].[CustomerEvents].[EventID],[dbo].[CustomerEvents].[IP],[dbo].[CustomerEvents].[OrderID],[dbo].[CustomerEvents].[SKU],[dbo].[CustomerEvents].[UserBehaviorID],[dbo].[CustomerEvents].[UserName]";
 
                public static int ReadCategoryID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["CategoryID"].ToString(), out result);
                                return result;
            }
                public static DateTime ReadEventDate(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["EventDate"].ToString(), out result);
                                return result;
            }
                public static int ReadEventID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["EventID"].ToString(), out result);
                                return result;
            }
                public static string ReadIP(DbDataReader rdr){
                string result;
                                result= rdr["IP"].ToString();
                                return result;
            }
                public static Guid ReadOrderID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["OrderID"];
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
                public static int ReadUserBehaviorID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["UserBehaviorID"].ToString(), out result);
                                return result;
            }
                public static string ReadUserName(DbDataReader rdr){
                string result;
                                result= rdr["UserName"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string CategoryID="@CategoryID";
                    public static string EventDate="@EventDate";
                    public static string EventID="@EventID";
                    public static string IP="@IP";
                    public static string OrderID="@OrderID";
                    public static string SKU="@SKU";
                    public static string UserBehaviorID="@UserBehaviorID";
                    public static string UserName="@UserName";
                }    
            
            public struct Columns{
                    public static string CategoryID="CategoryID";
                    public static string EventDate="EventDate";
                    public static string EventID="EventID";
                    public static string IP="IP";
                    public static string OrderID="OrderID";
                    public static string SKU="SKU";
                    public static string UserBehaviorID="UserBehaviorID";
                    public static string UserName="UserName";
                } 
            public struct ColumnsQualified{
                    public static string CategoryID="[dbo].[CustomerEvents].[CategoryID]";
                    public static string EventDate="[dbo].[CustomerEvents].[EventDate]";
                    public static string EventID="[dbo].[CustomerEvents].[EventID]";
                    public static string IP="[dbo].[CustomerEvents].[IP]";
                    public static string OrderID="[dbo].[CustomerEvents].[OrderID]";
                    public static string SKU="[dbo].[CustomerEvents].[SKU]";
                    public static string UserBehaviorID="[dbo].[CustomerEvents].[UserBehaviorID]";
                    public static string UserName="[dbo].[CustomerEvents].[UserName]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("CategoryID","[dbo].[CustomerEvents].[CategoryID]");
                            _qualifiedColumns.Add("EventDate","[dbo].[CustomerEvents].[EventDate]");
                            _qualifiedColumns.Add("EventID","[dbo].[CustomerEvents].[EventID]");
                            _qualifiedColumns.Add("IP","[dbo].[CustomerEvents].[IP]");
                            _qualifiedColumns.Add("OrderID","[dbo].[CustomerEvents].[OrderID]");
                            _qualifiedColumns.Add("SKU","[dbo].[CustomerEvents].[SKU]");
                            _qualifiedColumns.Add("UserBehaviorID","[dbo].[CustomerEvents].[UserBehaviorID]");
                            _qualifiedColumns.Add("UserName","[dbo].[CustomerEvents].[UserName]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[CustomerEvents](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[CustomerEvents]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[CustomerEvents]");
                return sql;
            }
        }
         

        public static class ProductOptionDisplaysTable{
            public const string TABLE_NAME=@"[dbo].[ProductOptionDisplays]";
            public const string COLUMN_LIST=@"[dbo].[ProductOptionDisplays].[HTMLDisplay],[dbo].[ProductOptionDisplays].[OptionDisplayID]";
 
                public static string ReadHTMLDisplay(DbDataReader rdr){
                string result;
                                result= rdr["HTMLDisplay"].ToString();
                                return result;
            }
                public static int ReadOptionDisplayID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["OptionDisplayID"].ToString(), out result);
                                return result;
            }
        
            
            public struct Parameters{
                    public static string HTMLDisplay="@HTMLDisplay";
                    public static string OptionDisplayID="@OptionDisplayID";
                }    
            
            public struct Columns{
                    public static string HTMLDisplay="HTMLDisplay";
                    public static string OptionDisplayID="OptionDisplayID";
                } 
            public struct ColumnsQualified{
                    public static string HTMLDisplay="[dbo].[ProductOptionDisplays].[HTMLDisplay]";
                    public static string OptionDisplayID="[dbo].[ProductOptionDisplays].[OptionDisplayID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("HTMLDisplay","[dbo].[ProductOptionDisplays].[HTMLDisplay]");
                            _qualifiedColumns.Add("OptionDisplayID","[dbo].[ProductOptionDisplays].[OptionDisplayID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[ProductOptionDisplays](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[ProductOptionDisplays]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[ProductOptionDisplays]");
                return sql;
            }
        }
         

        public static class ProductOptionsTable{
            public const string TABLE_NAME=@"[dbo].[ProductOptions]";
            public const string COLUMN_LIST=@"[dbo].[ProductOptions].[Description],[dbo].[ProductOptions].[DisplayID],[dbo].[ProductOptions].[LanguageCode],[dbo].[ProductOptions].[OptionID],[dbo].[ProductOptions].[Prompt]";
 
                public static string ReadDescription(DbDataReader rdr){
                string result;
                                result= rdr["Description"].ToString();
                                return result;
            }
                public static int ReadDisplayID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["DisplayID"].ToString(), out result);
                                return result;
            }
                public static string ReadLanguageCode(DbDataReader rdr){
                string result;
                                result= rdr["LanguageCode"].ToString();
                                return result;
            }
                public static int ReadOptionID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["OptionID"].ToString(), out result);
                                return result;
            }
                public static string ReadPrompt(DbDataReader rdr){
                string result;
                                result= rdr["Prompt"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Description="@Description";
                    public static string DisplayID="@DisplayID";
                    public static string LanguageCode="@LanguageCode";
                    public static string OptionID="@OptionID";
                    public static string Prompt="@Prompt";
                }    
            
            public struct Columns{
                    public static string Description="Description";
                    public static string DisplayID="DisplayID";
                    public static string LanguageCode="LanguageCode";
                    public static string OptionID="OptionID";
                    public static string Prompt="Prompt";
                } 
            public struct ColumnsQualified{
                    public static string Description="[dbo].[ProductOptions].[Description]";
                    public static string DisplayID="[dbo].[ProductOptions].[DisplayID]";
                    public static string LanguageCode="[dbo].[ProductOptions].[LanguageCode]";
                    public static string OptionID="[dbo].[ProductOptions].[OptionID]";
                    public static string Prompt="[dbo].[ProductOptions].[Prompt]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Description","[dbo].[ProductOptions].[Description]");
                            _qualifiedColumns.Add("DisplayID","[dbo].[ProductOptions].[DisplayID]");
                            _qualifiedColumns.Add("LanguageCode","[dbo].[ProductOptions].[LanguageCode]");
                            _qualifiedColumns.Add("OptionID","[dbo].[ProductOptions].[OptionID]");
                            _qualifiedColumns.Add("Prompt","[dbo].[ProductOptions].[Prompt]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[ProductOptions](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[ProductOptions]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[ProductOptions]");
                return sql;
            }
        }
         

        public static class WidgetsTable{
            public const string TABLE_NAME=@"[dbo].[Widgets]";
            public const string COLUMN_LIST=@"[dbo].[Widgets].[Body],[dbo].[Widgets].[CreatedBy],[dbo].[Widgets].[CreatedOn],[dbo].[Widgets].[EditorName],[dbo].[Widgets].[IsTyped],[dbo].[Widgets].[LanguageCode],[dbo].[Widgets].[ListOrder],[dbo].[Widgets].[ModifiedBy],[dbo].[Widgets].[ModifiedOn],[dbo].[Widgets].[PageID],[dbo].[Widgets].[Title],[dbo].[Widgets].[ViewName],[dbo].[Widgets].[WidgetID],[dbo].[Widgets].[Zone]";
 
                public static string ReadBody(DbDataReader rdr){
                string result;
                                result= rdr["Body"].ToString();
                                return result;
            }
                public static string ReadCreatedBy(DbDataReader rdr){
                string result;
                                result= rdr["CreatedBy"].ToString();
                                return result;
            }
                public static DateTime ReadCreatedOn(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["CreatedOn"].ToString(), out result);
                                return result;
            }
                public static string ReadEditorName(DbDataReader rdr){
                string result;
                                result= rdr["EditorName"].ToString();
                                return result;
            }
                public static bool ReadIsTyped(DbDataReader rdr){
                bool result;
                                bool.TryParse(rdr["IsTyped"].ToString(), out result);
                                return result;
            }
                public static string ReadLanguageCode(DbDataReader rdr){
                string result;
                                result= rdr["LanguageCode"].ToString();
                                return result;
            }
                public static int ReadListOrder(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["ListOrder"].ToString(), out result);
                                return result;
            }
                public static string ReadModifiedBy(DbDataReader rdr){
                string result;
                                result= rdr["ModifiedBy"].ToString();
                                return result;
            }
                public static DateTime ReadModifiedOn(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["ModifiedOn"].ToString(), out result);
                                return result;
            }
                public static Guid ReadPageID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["PageID"];
                                return result;
            }
                public static string ReadTitle(DbDataReader rdr){
                string result;
                                result= rdr["Title"].ToString();
                                return result;
            }
                public static string ReadViewName(DbDataReader rdr){
                string result;
                                result= rdr["ViewName"].ToString();
                                return result;
            }
                public static Guid ReadWidgetID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["WidgetID"];
                                return result;
            }
                public static string ReadZone(DbDataReader rdr){
                string result;
                                result= rdr["Zone"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Body="@Body";
                    public static string CreatedBy="@CreatedBy";
                    public static string CreatedOn="@CreatedOn";
                    public static string EditorName="@EditorName";
                    public static string IsTyped="@IsTyped";
                    public static string LanguageCode="@LanguageCode";
                    public static string ListOrder="@ListOrder";
                    public static string ModifiedBy="@ModifiedBy";
                    public static string ModifiedOn="@ModifiedOn";
                    public static string PageID="@PageID";
                    public static string Title="@Title";
                    public static string ViewName="@ViewName";
                    public static string WidgetID="@WidgetID";
                    public static string Zone="@Zone";
                }    
            
            public struct Columns{
                    public static string Body="Body";
                    public static string CreatedBy="CreatedBy";
                    public static string CreatedOn="CreatedOn";
                    public static string EditorName="EditorName";
                    public static string IsTyped="IsTyped";
                    public static string LanguageCode="LanguageCode";
                    public static string ListOrder="ListOrder";
                    public static string ModifiedBy="ModifiedBy";
                    public static string ModifiedOn="ModifiedOn";
                    public static string PageID="PageID";
                    public static string Title="Title";
                    public static string ViewName="ViewName";
                    public static string WidgetID="WidgetID";
                    public static string Zone="Zone";
                } 
            public struct ColumnsQualified{
                    public static string Body="[dbo].[Widgets].[Body]";
                    public static string CreatedBy="[dbo].[Widgets].[CreatedBy]";
                    public static string CreatedOn="[dbo].[Widgets].[CreatedOn]";
                    public static string EditorName="[dbo].[Widgets].[EditorName]";
                    public static string IsTyped="[dbo].[Widgets].[IsTyped]";
                    public static string LanguageCode="[dbo].[Widgets].[LanguageCode]";
                    public static string ListOrder="[dbo].[Widgets].[ListOrder]";
                    public static string ModifiedBy="[dbo].[Widgets].[ModifiedBy]";
                    public static string ModifiedOn="[dbo].[Widgets].[ModifiedOn]";
                    public static string PageID="[dbo].[Widgets].[PageID]";
                    public static string Title="[dbo].[Widgets].[Title]";
                    public static string ViewName="[dbo].[Widgets].[ViewName]";
                    public static string WidgetID="[dbo].[Widgets].[WidgetID]";
                    public static string Zone="[dbo].[Widgets].[Zone]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Body","[dbo].[Widgets].[Body]");
                            _qualifiedColumns.Add("CreatedBy","[dbo].[Widgets].[CreatedBy]");
                            _qualifiedColumns.Add("CreatedOn","[dbo].[Widgets].[CreatedOn]");
                            _qualifiedColumns.Add("EditorName","[dbo].[Widgets].[EditorName]");
                            _qualifiedColumns.Add("IsTyped","[dbo].[Widgets].[IsTyped]");
                            _qualifiedColumns.Add("LanguageCode","[dbo].[Widgets].[LanguageCode]");
                            _qualifiedColumns.Add("ListOrder","[dbo].[Widgets].[ListOrder]");
                            _qualifiedColumns.Add("ModifiedBy","[dbo].[Widgets].[ModifiedBy]");
                            _qualifiedColumns.Add("ModifiedOn","[dbo].[Widgets].[ModifiedOn]");
                            _qualifiedColumns.Add("PageID","[dbo].[Widgets].[PageID]");
                            _qualifiedColumns.Add("Title","[dbo].[Widgets].[Title]");
                            _qualifiedColumns.Add("ViewName","[dbo].[Widgets].[ViewName]");
                            _qualifiedColumns.Add("WidgetID","[dbo].[Widgets].[WidgetID]");
                            _qualifiedColumns.Add("Zone","[dbo].[Widgets].[Zone]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Widgets](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Widgets]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Widgets]");
                return sql;
            }
        }
         

        public static class ProductOptionValuesTable{
            public const string TABLE_NAME=@"[dbo].[ProductOptionValues]";
            public const string COLUMN_LIST=@"[dbo].[ProductOptionValues].[Description],[dbo].[ProductOptionValues].[OptionID],[dbo].[ProductOptionValues].[OptionValueID]";
 
                public static string ReadDescription(DbDataReader rdr){
                string result;
                                result= rdr["Description"].ToString();
                                return result;
            }
                public static int ReadOptionID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["OptionID"].ToString(), out result);
                                return result;
            }
                public static int ReadOptionValueID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["OptionValueID"].ToString(), out result);
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Description="@Description";
                    public static string OptionID="@OptionID";
                    public static string OptionValueID="@OptionValueID";
                }    
            
            public struct Columns{
                    public static string Description="Description";
                    public static string OptionID="OptionID";
                    public static string OptionValueID="OptionValueID";
                } 
            public struct ColumnsQualified{
                    public static string Description="[dbo].[ProductOptionValues].[Description]";
                    public static string OptionID="[dbo].[ProductOptionValues].[OptionID]";
                    public static string OptionValueID="[dbo].[ProductOptionValues].[OptionValueID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Description","[dbo].[ProductOptionValues].[Description]");
                            _qualifiedColumns.Add("OptionID","[dbo].[ProductOptionValues].[OptionID]");
                            _qualifiedColumns.Add("OptionValueID","[dbo].[ProductOptionValues].[OptionValueID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[ProductOptionValues](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[ProductOptionValues]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[ProductOptionValues]");
                return sql;
            }
        }
         

        public static class Products_OptionsTable{
            public const string TABLE_NAME=@"[dbo].[Products_Options]";
            public const string COLUMN_LIST=@"[dbo].[Products_Options].[OptionID],[dbo].[Products_Options].[OptionValueID],[dbo].[Products_Options].[SKU]";
 
                public static int ReadOptionID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["OptionID"].ToString(), out result);
                                return result;
            }
                public static int ReadOptionValueID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["OptionValueID"].ToString(), out result);
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string OptionID="@OptionID";
                    public static string OptionValueID="@OptionValueID";
                    public static string SKU="@SKU";
                }    
            
            public struct Columns{
                    public static string OptionID="OptionID";
                    public static string OptionValueID="OptionValueID";
                    public static string SKU="SKU";
                } 
            public struct ColumnsQualified{
                    public static string OptionID="[dbo].[Products_Options].[OptionID]";
                    public static string OptionValueID="[dbo].[Products_Options].[OptionValueID]";
                    public static string SKU="[dbo].[Products_Options].[SKU]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("OptionID","[dbo].[Products_Options].[OptionID]");
                            _qualifiedColumns.Add("OptionValueID","[dbo].[Products_Options].[OptionValueID]");
                            _qualifiedColumns.Add("SKU","[dbo].[Products_Options].[SKU]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Products_Options](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Products_Options]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Products_Options]");
                return sql;
            }
        }
         

        public static class CartItemsTable{
            public const string TABLE_NAME=@"[dbo].[CartItems]";
            public const string COLUMN_LIST=@"[dbo].[CartItems].[DateAdded],[dbo].[CartItems].[DiscountAmount],[dbo].[CartItems].[DiscountReason],[dbo].[CartItems].[Quantity],[dbo].[CartItems].[SKU],[dbo].[CartItems].[UserName]";
 
                public static DateTime ReadDateAdded(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["DateAdded"].ToString(), out result);
                                return result;
            }
                public static decimal ReadDiscountAmount(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["DiscountAmount"].ToString(), out result);
                                return result;
            }
                public static string ReadDiscountReason(DbDataReader rdr){
                string result;
                                result= rdr["DiscountReason"].ToString();
                                return result;
            }
                public static int ReadQuantity(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["Quantity"].ToString(), out result);
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
                public static string ReadUserName(DbDataReader rdr){
                string result;
                                result= rdr["UserName"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string DateAdded="@DateAdded";
                    public static string DiscountAmount="@DiscountAmount";
                    public static string DiscountReason="@DiscountReason";
                    public static string Quantity="@Quantity";
                    public static string SKU="@SKU";
                    public static string UserName="@UserName";
                }    
            
            public struct Columns{
                    public static string DateAdded="DateAdded";
                    public static string DiscountAmount="DiscountAmount";
                    public static string DiscountReason="DiscountReason";
                    public static string Quantity="Quantity";
                    public static string SKU="SKU";
                    public static string UserName="UserName";
                } 
            public struct ColumnsQualified{
                    public static string DateAdded="[dbo].[CartItems].[DateAdded]";
                    public static string DiscountAmount="[dbo].[CartItems].[DiscountAmount]";
                    public static string DiscountReason="[dbo].[CartItems].[DiscountReason]";
                    public static string Quantity="[dbo].[CartItems].[Quantity]";
                    public static string SKU="[dbo].[CartItems].[SKU]";
                    public static string UserName="[dbo].[CartItems].[UserName]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("DateAdded","[dbo].[CartItems].[DateAdded]");
                            _qualifiedColumns.Add("DiscountAmount","[dbo].[CartItems].[DiscountAmount]");
                            _qualifiedColumns.Add("DiscountReason","[dbo].[CartItems].[DiscountReason]");
                            _qualifiedColumns.Add("Quantity","[dbo].[CartItems].[Quantity]");
                            _qualifiedColumns.Add("SKU","[dbo].[CartItems].[SKU]");
                            _qualifiedColumns.Add("UserName","[dbo].[CartItems].[UserName]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[CartItems](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[CartItems]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[CartItems]");
                return sql;
            }
        }
         

        public static class OrderItemsTable{
            public const string TABLE_NAME=@"[dbo].[OrderItems]";
            public const string COLUMN_LIST=@"[dbo].[OrderItems].[DateAdded],[dbo].[OrderItems].[Discount],[dbo].[OrderItems].[DiscountReason],[dbo].[OrderItems].[LineItemPrice],[dbo].[OrderItems].[LineItemWeightInPounds],[dbo].[OrderItems].[OrderID],[dbo].[OrderItems].[Quantity],[dbo].[OrderItems].[SKU],[dbo].[OrderItems].[Version]";
 
                public static DateTime ReadDateAdded(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["DateAdded"].ToString(), out result);
                                return result;
            }
                public static decimal ReadDiscount(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["Discount"].ToString(), out result);
                                return result;
            }
                public static string ReadDiscountReason(DbDataReader rdr){
                string result;
                                result= rdr["DiscountReason"].ToString();
                                return result;
            }
                public static decimal ReadLineItemPrice(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["LineItemPrice"].ToString(), out result);
                                return result;
            }
                public static decimal ReadLineItemWeightInPounds(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["LineItemWeightInPounds"].ToString(), out result);
                                return result;
            }
                public static Guid ReadOrderID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["OrderID"];
                                return result;
            }
                public static int ReadQuantity(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["Quantity"].ToString(), out result);
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
                public static string ReadVersion(DbDataReader rdr){
                string result;
                                result= rdr["Version"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string DateAdded="@DateAdded";
                    public static string Discount="@Discount";
                    public static string DiscountReason="@DiscountReason";
                    public static string LineItemPrice="@LineItemPrice";
                    public static string LineItemWeightInPounds="@LineItemWeightInPounds";
                    public static string OrderID="@OrderID";
                    public static string Quantity="@Quantity";
                    public static string SKU="@SKU";
                    public static string Version="@Version";
                }    
            
            public struct Columns{
                    public static string DateAdded="DateAdded";
                    public static string Discount="Discount";
                    public static string DiscountReason="DiscountReason";
                    public static string LineItemPrice="LineItemPrice";
                    public static string LineItemWeightInPounds="LineItemWeightInPounds";
                    public static string OrderID="OrderID";
                    public static string Quantity="Quantity";
                    public static string SKU="SKU";
                    public static string Version="Version";
                } 
            public struct ColumnsQualified{
                    public static string DateAdded="[dbo].[OrderItems].[DateAdded]";
                    public static string Discount="[dbo].[OrderItems].[Discount]";
                    public static string DiscountReason="[dbo].[OrderItems].[DiscountReason]";
                    public static string LineItemPrice="[dbo].[OrderItems].[LineItemPrice]";
                    public static string LineItemWeightInPounds="[dbo].[OrderItems].[LineItemWeightInPounds]";
                    public static string OrderID="[dbo].[OrderItems].[OrderID]";
                    public static string Quantity="[dbo].[OrderItems].[Quantity]";
                    public static string SKU="[dbo].[OrderItems].[SKU]";
                    public static string Version="[dbo].[OrderItems].[Version]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("DateAdded","[dbo].[OrderItems].[DateAdded]");
                            _qualifiedColumns.Add("Discount","[dbo].[OrderItems].[Discount]");
                            _qualifiedColumns.Add("DiscountReason","[dbo].[OrderItems].[DiscountReason]");
                            _qualifiedColumns.Add("LineItemPrice","[dbo].[OrderItems].[LineItemPrice]");
                            _qualifiedColumns.Add("LineItemWeightInPounds","[dbo].[OrderItems].[LineItemWeightInPounds]");
                            _qualifiedColumns.Add("OrderID","[dbo].[OrderItems].[OrderID]");
                            _qualifiedColumns.Add("Quantity","[dbo].[OrderItems].[Quantity]");
                            _qualifiedColumns.Add("SKU","[dbo].[OrderItems].[SKU]");
                            _qualifiedColumns.Add("Version","[dbo].[OrderItems].[Version]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[OrderItems](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[OrderItems]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[OrderItems]");
                return sql;
            }
        }
         

        public static class ProductsTable{
            public const string TABLE_NAME=@"[dbo].[Products]";
            public const string COLUMN_LIST=@"[dbo].[Products].[AllowBackOrder],[dbo].[Products].[AllowPreOrder],[dbo].[Products].[AmountOnHand],[dbo].[Products].[BasePrice],[dbo].[Products].[DateAvailable],[dbo].[Products].[DefaultImageFile],[dbo].[Products].[DeliveryMethodID],[dbo].[Products].[EstimatedDelivery],[dbo].[Products].[InventoryStatusID],[dbo].[Products].[IsTaxable],[dbo].[Products].[Options],[dbo].[Products].[ProductName],[dbo].[Products].[SiteID],[dbo].[Products].[SKU],[dbo].[Products].[Version],[dbo].[Products].[WeightInPounds]";
 
                public static bool ReadAllowBackOrder(DbDataReader rdr){
                bool result;
                                bool.TryParse(rdr["AllowBackOrder"].ToString(), out result);
                                return result;
            }
                public static bool ReadAllowPreOrder(DbDataReader rdr){
                bool result;
                                bool.TryParse(rdr["AllowPreOrder"].ToString(), out result);
                                return result;
            }
                public static int ReadAmountOnHand(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["AmountOnHand"].ToString(), out result);
                                return result;
            }
                public static decimal ReadBasePrice(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["BasePrice"].ToString(), out result);
                                return result;
            }
                public static DateTime ReadDateAvailable(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["DateAvailable"].ToString(), out result);
                                return result;
            }
                public static string ReadDefaultImageFile(DbDataReader rdr){
                string result;
                                result= rdr["DefaultImageFile"].ToString();
                                return result;
            }
                public static int ReadDeliveryMethodID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["DeliveryMethodID"].ToString(), out result);
                                return result;
            }
                public static string ReadEstimatedDelivery(DbDataReader rdr){
                string result;
                                result= rdr["EstimatedDelivery"].ToString();
                                return result;
            }
                public static int ReadInventoryStatusID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["InventoryStatusID"].ToString(), out result);
                                return result;
            }
                public static bool ReadIsTaxable(DbDataReader rdr){
                bool result;
                                bool.TryParse(rdr["IsTaxable"].ToString(), out result);
                                return result;
            }
                public static byte[] ReadOptions(DbDataReader rdr){
                byte[] result;
                                result=(byte[])rdr["Options"];
                                return result;
            }
                public static string ReadProductName(DbDataReader rdr){
                string result;
                                result= rdr["ProductName"].ToString();
                                return result;
            }
                public static Guid ReadSiteID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["SiteID"];
                                return result;
            }
                public static string ReadSKU(DbDataReader rdr){
                string result;
                                result= rdr["SKU"].ToString();
                                return result;
            }
                public static string ReadVersion(DbDataReader rdr){
                string result;
                                result= rdr["Version"].ToString();
                                return result;
            }
                public static decimal ReadWeightInPounds(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["WeightInPounds"].ToString(), out result);
                                return result;
            }
        
            
            public struct Parameters{
                    public static string AllowBackOrder="@AllowBackOrder";
                    public static string AllowPreOrder="@AllowPreOrder";
                    public static string AmountOnHand="@AmountOnHand";
                    public static string BasePrice="@BasePrice";
                    public static string DateAvailable="@DateAvailable";
                    public static string DefaultImageFile="@DefaultImageFile";
                    public static string DeliveryMethodID="@DeliveryMethodID";
                    public static string EstimatedDelivery="@EstimatedDelivery";
                    public static string InventoryStatusID="@InventoryStatusID";
                    public static string IsTaxable="@IsTaxable";
                    public static string Options="@Options";
                    public static string ProductName="@ProductName";
                    public static string SiteID="@SiteID";
                    public static string SKU="@SKU";
                    public static string Version="@Version";
                    public static string WeightInPounds="@WeightInPounds";
                }    
            
            public struct Columns{
                    public static string AllowBackOrder="AllowBackOrder";
                    public static string AllowPreOrder="AllowPreOrder";
                    public static string AmountOnHand="AmountOnHand";
                    public static string BasePrice="BasePrice";
                    public static string DateAvailable="DateAvailable";
                    public static string DefaultImageFile="DefaultImageFile";
                    public static string DeliveryMethodID="DeliveryMethodID";
                    public static string EstimatedDelivery="EstimatedDelivery";
                    public static string InventoryStatusID="InventoryStatusID";
                    public static string IsTaxable="IsTaxable";
                    public static string Options="Options";
                    public static string ProductName="ProductName";
                    public static string SiteID="SiteID";
                    public static string SKU="SKU";
                    public static string Version="Version";
                    public static string WeightInPounds="WeightInPounds";
                } 
            public struct ColumnsQualified{
                    public static string AllowBackOrder="[dbo].[Products].[AllowBackOrder]";
                    public static string AllowPreOrder="[dbo].[Products].[AllowPreOrder]";
                    public static string AmountOnHand="[dbo].[Products].[AmountOnHand]";
                    public static string BasePrice="[dbo].[Products].[BasePrice]";
                    public static string DateAvailable="[dbo].[Products].[DateAvailable]";
                    public static string DefaultImageFile="[dbo].[Products].[DefaultImageFile]";
                    public static string DeliveryMethodID="[dbo].[Products].[DeliveryMethodID]";
                    public static string EstimatedDelivery="[dbo].[Products].[EstimatedDelivery]";
                    public static string InventoryStatusID="[dbo].[Products].[InventoryStatusID]";
                    public static string IsTaxable="[dbo].[Products].[IsTaxable]";
                    public static string Options="[dbo].[Products].[Options]";
                    public static string ProductName="[dbo].[Products].[ProductName]";
                    public static string SiteID="[dbo].[Products].[SiteID]";
                    public static string SKU="[dbo].[Products].[SKU]";
                    public static string Version="[dbo].[Products].[Version]";
                    public static string WeightInPounds="[dbo].[Products].[WeightInPounds]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("AllowBackOrder","[dbo].[Products].[AllowBackOrder]");
                            _qualifiedColumns.Add("AllowPreOrder","[dbo].[Products].[AllowPreOrder]");
                            _qualifiedColumns.Add("AmountOnHand","[dbo].[Products].[AmountOnHand]");
                            _qualifiedColumns.Add("BasePrice","[dbo].[Products].[BasePrice]");
                            _qualifiedColumns.Add("DateAvailable","[dbo].[Products].[DateAvailable]");
                            _qualifiedColumns.Add("DefaultImageFile","[dbo].[Products].[DefaultImageFile]");
                            _qualifiedColumns.Add("DeliveryMethodID","[dbo].[Products].[DeliveryMethodID]");
                            _qualifiedColumns.Add("EstimatedDelivery","[dbo].[Products].[EstimatedDelivery]");
                            _qualifiedColumns.Add("InventoryStatusID","[dbo].[Products].[InventoryStatusID]");
                            _qualifiedColumns.Add("IsTaxable","[dbo].[Products].[IsTaxable]");
                            _qualifiedColumns.Add("Options","[dbo].[Products].[Options]");
                            _qualifiedColumns.Add("ProductName","[dbo].[Products].[ProductName]");
                            _qualifiedColumns.Add("SiteID","[dbo].[Products].[SiteID]");
                            _qualifiedColumns.Add("SKU","[dbo].[Products].[SKU]");
                            _qualifiedColumns.Add("Version","[dbo].[Products].[Version]");
                            _qualifiedColumns.Add("WeightInPounds","[dbo].[Products].[WeightInPounds]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Products](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Products]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Products]");
                return sql;
            }
        }
         

        public static class OrdersTable{
            public const string TABLE_NAME=@"[dbo].[Orders]";
            public const string COLUMN_LIST=@"[dbo].[Orders].[BillingAddressID],[dbo].[Orders].[CreatedOn],[dbo].[Orders].[DateShipped],[dbo].[Orders].[DiscountAmount],[dbo].[Orders].[DiscountReason],[dbo].[Orders].[EstimatedDelivery],[dbo].[Orders].[ExecutedOn],[dbo].[Orders].[ModifiedOn],[dbo].[Orders].[OrderID],[dbo].[Orders].[OrderNumber],[dbo].[Orders].[OrderStatusID],[dbo].[Orders].[ShippingAddressID],[dbo].[Orders].[ShippingAmount],[dbo].[Orders].[ShippingService],[dbo].[Orders].[SubTotal],[dbo].[Orders].[TaxAmount],[dbo].[Orders].[TrackingNumber],[dbo].[Orders].[UserLanguageCode],[dbo].[Orders].[UserName],[dbo].[Orders].[Version]";
 
                public static int ReadBillingAddressID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["BillingAddressID"].ToString(), out result);
                                return result;
            }
                public static DateTime ReadCreatedOn(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["CreatedOn"].ToString(), out result);
                                return result;
            }
                public static DateTime ReadDateShipped(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["DateShipped"].ToString(), out result);
                                return result;
            }
                public static decimal ReadDiscountAmount(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["DiscountAmount"].ToString(), out result);
                                return result;
            }
                public static string ReadDiscountReason(DbDataReader rdr){
                string result;
                                result= rdr["DiscountReason"].ToString();
                                return result;
            }
                public static DateTime ReadEstimatedDelivery(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["EstimatedDelivery"].ToString(), out result);
                                return result;
            }
                public static DateTime ReadExecutedOn(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["ExecutedOn"].ToString(), out result);
                                return result;
            }
                public static DateTime ReadModifiedOn(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["ModifiedOn"].ToString(), out result);
                                return result;
            }
                public static Guid ReadOrderID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["OrderID"];
                                return result;
            }
                public static string ReadOrderNumber(DbDataReader rdr){
                string result;
                                result= rdr["OrderNumber"].ToString();
                                return result;
            }
                public static int ReadOrderStatusID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["OrderStatusID"].ToString(), out result);
                                return result;
            }
                public static int ReadShippingAddressID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["ShippingAddressID"].ToString(), out result);
                                return result;
            }
                public static decimal ReadShippingAmount(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["ShippingAmount"].ToString(), out result);
                                return result;
            }
                public static string ReadShippingService(DbDataReader rdr){
                string result;
                                result= rdr["ShippingService"].ToString();
                                return result;
            }
                public static decimal ReadSubTotal(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["SubTotal"].ToString(), out result);
                                return result;
            }
                public static decimal ReadTaxAmount(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["TaxAmount"].ToString(), out result);
                                return result;
            }
                public static string ReadTrackingNumber(DbDataReader rdr){
                string result;
                                result= rdr["TrackingNumber"].ToString();
                                return result;
            }
                public static string ReadUserLanguageCode(DbDataReader rdr){
                string result;
                                result= rdr["UserLanguageCode"].ToString();
                                return result;
            }
                public static string ReadUserName(DbDataReader rdr){
                string result;
                                result= rdr["UserName"].ToString();
                                return result;
            }
                public static string ReadVersion(DbDataReader rdr){
                string result;
                                result= rdr["Version"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string BillingAddressID="@BillingAddressID";
                    public static string CreatedOn="@CreatedOn";
                    public static string DateShipped="@DateShipped";
                    public static string DiscountAmount="@DiscountAmount";
                    public static string DiscountReason="@DiscountReason";
                    public static string EstimatedDelivery="@EstimatedDelivery";
                    public static string ExecutedOn="@ExecutedOn";
                    public static string ModifiedOn="@ModifiedOn";
                    public static string OrderID="@OrderID";
                    public static string OrderNumber="@OrderNumber";
                    public static string OrderStatusID="@OrderStatusID";
                    public static string ShippingAddressID="@ShippingAddressID";
                    public static string ShippingAmount="@ShippingAmount";
                    public static string ShippingService="@ShippingService";
                    public static string SubTotal="@SubTotal";
                    public static string TaxAmount="@TaxAmount";
                    public static string TrackingNumber="@TrackingNumber";
                    public static string UserLanguageCode="@UserLanguageCode";
                    public static string UserName="@UserName";
                    public static string Version="@Version";
                }    
            
            public struct Columns{
                    public static string BillingAddressID="BillingAddressID";
                    public static string CreatedOn="CreatedOn";
                    public static string DateShipped="DateShipped";
                    public static string DiscountAmount="DiscountAmount";
                    public static string DiscountReason="DiscountReason";
                    public static string EstimatedDelivery="EstimatedDelivery";
                    public static string ExecutedOn="ExecutedOn";
                    public static string ModifiedOn="ModifiedOn";
                    public static string OrderID="OrderID";
                    public static string OrderNumber="OrderNumber";
                    public static string OrderStatusID="OrderStatusID";
                    public static string ShippingAddressID="ShippingAddressID";
                    public static string ShippingAmount="ShippingAmount";
                    public static string ShippingService="ShippingService";
                    public static string SubTotal="SubTotal";
                    public static string TaxAmount="TaxAmount";
                    public static string TrackingNumber="TrackingNumber";
                    public static string UserLanguageCode="UserLanguageCode";
                    public static string UserName="UserName";
                    public static string Version="Version";
                } 
            public struct ColumnsQualified{
                    public static string BillingAddressID="[dbo].[Orders].[BillingAddressID]";
                    public static string CreatedOn="[dbo].[Orders].[CreatedOn]";
                    public static string DateShipped="[dbo].[Orders].[DateShipped]";
                    public static string DiscountAmount="[dbo].[Orders].[DiscountAmount]";
                    public static string DiscountReason="[dbo].[Orders].[DiscountReason]";
                    public static string EstimatedDelivery="[dbo].[Orders].[EstimatedDelivery]";
                    public static string ExecutedOn="[dbo].[Orders].[ExecutedOn]";
                    public static string ModifiedOn="[dbo].[Orders].[ModifiedOn]";
                    public static string OrderID="[dbo].[Orders].[OrderID]";
                    public static string OrderNumber="[dbo].[Orders].[OrderNumber]";
                    public static string OrderStatusID="[dbo].[Orders].[OrderStatusID]";
                    public static string ShippingAddressID="[dbo].[Orders].[ShippingAddressID]";
                    public static string ShippingAmount="[dbo].[Orders].[ShippingAmount]";
                    public static string ShippingService="[dbo].[Orders].[ShippingService]";
                    public static string SubTotal="[dbo].[Orders].[SubTotal]";
                    public static string TaxAmount="[dbo].[Orders].[TaxAmount]";
                    public static string TrackingNumber="[dbo].[Orders].[TrackingNumber]";
                    public static string UserLanguageCode="[dbo].[Orders].[UserLanguageCode]";
                    public static string UserName="[dbo].[Orders].[UserName]";
                    public static string Version="[dbo].[Orders].[Version]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("BillingAddressID","[dbo].[Orders].[BillingAddressID]");
                            _qualifiedColumns.Add("CreatedOn","[dbo].[Orders].[CreatedOn]");
                            _qualifiedColumns.Add("DateShipped","[dbo].[Orders].[DateShipped]");
                            _qualifiedColumns.Add("DiscountAmount","[dbo].[Orders].[DiscountAmount]");
                            _qualifiedColumns.Add("DiscountReason","[dbo].[Orders].[DiscountReason]");
                            _qualifiedColumns.Add("EstimatedDelivery","[dbo].[Orders].[EstimatedDelivery]");
                            _qualifiedColumns.Add("ExecutedOn","[dbo].[Orders].[ExecutedOn]");
                            _qualifiedColumns.Add("ModifiedOn","[dbo].[Orders].[ModifiedOn]");
                            _qualifiedColumns.Add("OrderID","[dbo].[Orders].[OrderID]");
                            _qualifiedColumns.Add("OrderNumber","[dbo].[Orders].[OrderNumber]");
                            _qualifiedColumns.Add("OrderStatusID","[dbo].[Orders].[OrderStatusID]");
                            _qualifiedColumns.Add("ShippingAddressID","[dbo].[Orders].[ShippingAddressID]");
                            _qualifiedColumns.Add("ShippingAmount","[dbo].[Orders].[ShippingAmount]");
                            _qualifiedColumns.Add("ShippingService","[dbo].[Orders].[ShippingService]");
                            _qualifiedColumns.Add("SubTotal","[dbo].[Orders].[SubTotal]");
                            _qualifiedColumns.Add("TaxAmount","[dbo].[Orders].[TaxAmount]");
                            _qualifiedColumns.Add("TrackingNumber","[dbo].[Orders].[TrackingNumber]");
                            _qualifiedColumns.Add("UserLanguageCode","[dbo].[Orders].[UserLanguageCode]");
                            _qualifiedColumns.Add("UserName","[dbo].[Orders].[UserName]");
                            _qualifiedColumns.Add("Version","[dbo].[Orders].[Version]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Orders](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Orders]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Orders]");
                return sql;
            }
        }
         

        public static class ShippingMethodsTable{
            public const string TABLE_NAME=@"[dbo].[ShippingMethods]";
            public const string COLUMN_LIST=@"[dbo].[ShippingMethods].[BaseRate],[dbo].[ShippingMethods].[Carrier],[dbo].[ShippingMethods].[DaysToDeliver],[dbo].[ShippingMethods].[EstimatedDelivery],[dbo].[ShippingMethods].[RatePerPound],[dbo].[ShippingMethods].[ServiceName],[dbo].[ShippingMethods].[ShippingMethodID]";
 
                public static decimal ReadBaseRate(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["BaseRate"].ToString(), out result);
                                return result;
            }
                public static string ReadCarrier(DbDataReader rdr){
                string result;
                                result= rdr["Carrier"].ToString();
                                return result;
            }
                public static int ReadDaysToDeliver(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["DaysToDeliver"].ToString(), out result);
                                return result;
            }
                public static string ReadEstimatedDelivery(DbDataReader rdr){
                string result;
                                result= rdr["EstimatedDelivery"].ToString();
                                return result;
            }
                public static decimal ReadRatePerPound(DbDataReader rdr){
                decimal result;
                                decimal.TryParse(rdr["RatePerPound"].ToString(), out result);
                                return result;
            }
                public static string ReadServiceName(DbDataReader rdr){
                string result;
                                result= rdr["ServiceName"].ToString();
                                return result;
            }
                public static int ReadShippingMethodID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["ShippingMethodID"].ToString(), out result);
                                return result;
            }
        
            
            public struct Parameters{
                    public static string BaseRate="@BaseRate";
                    public static string Carrier="@Carrier";
                    public static string DaysToDeliver="@DaysToDeliver";
                    public static string EstimatedDelivery="@EstimatedDelivery";
                    public static string RatePerPound="@RatePerPound";
                    public static string ServiceName="@ServiceName";
                    public static string ShippingMethodID="@ShippingMethodID";
                }    
            
            public struct Columns{
                    public static string BaseRate="BaseRate";
                    public static string Carrier="Carrier";
                    public static string DaysToDeliver="DaysToDeliver";
                    public static string EstimatedDelivery="EstimatedDelivery";
                    public static string RatePerPound="RatePerPound";
                    public static string ServiceName="ServiceName";
                    public static string ShippingMethodID="ShippingMethodID";
                } 
            public struct ColumnsQualified{
                    public static string BaseRate="[dbo].[ShippingMethods].[BaseRate]";
                    public static string Carrier="[dbo].[ShippingMethods].[Carrier]";
                    public static string DaysToDeliver="[dbo].[ShippingMethods].[DaysToDeliver]";
                    public static string EstimatedDelivery="[dbo].[ShippingMethods].[EstimatedDelivery]";
                    public static string RatePerPound="[dbo].[ShippingMethods].[RatePerPound]";
                    public static string ServiceName="[dbo].[ShippingMethods].[ServiceName]";
                    public static string ShippingMethodID="[dbo].[ShippingMethods].[ShippingMethodID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("BaseRate","[dbo].[ShippingMethods].[BaseRate]");
                            _qualifiedColumns.Add("Carrier","[dbo].[ShippingMethods].[Carrier]");
                            _qualifiedColumns.Add("DaysToDeliver","[dbo].[ShippingMethods].[DaysToDeliver]");
                            _qualifiedColumns.Add("EstimatedDelivery","[dbo].[ShippingMethods].[EstimatedDelivery]");
                            _qualifiedColumns.Add("RatePerPound","[dbo].[ShippingMethods].[RatePerPound]");
                            _qualifiedColumns.Add("ServiceName","[dbo].[ShippingMethods].[ServiceName]");
                            _qualifiedColumns.Add("ShippingMethodID","[dbo].[ShippingMethods].[ShippingMethodID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[ShippingMethods](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[ShippingMethods]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[ShippingMethods]");
                return sql;
            }
        }
         

        public static class CategoriesTable{
            public const string TABLE_NAME=@"[dbo].[Categories]";
            public const string COLUMN_LIST=@"[dbo].[Categories].[CategoryID],[dbo].[Categories].[DefaultImageFile],[dbo].[Categories].[IsDefault],[dbo].[Categories].[ParentID],[dbo].[Categories].[SiteID]";
 
                public static int ReadCategoryID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["CategoryID"].ToString(), out result);
                                return result;
            }
                public static string ReadDefaultImageFile(DbDataReader rdr){
                string result;
                                result= rdr["DefaultImageFile"].ToString();
                                return result;
            }
                public static bool ReadIsDefault(DbDataReader rdr){
                bool result;
                                bool.TryParse(rdr["IsDefault"].ToString(), out result);
                                return result;
            }
                public static int ReadParentID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["ParentID"].ToString(), out result);
                                return result;
            }
                public static Guid ReadSiteID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["SiteID"];
                                return result;
            }
        
            
            public struct Parameters{
                    public static string CategoryID="@CategoryID";
                    public static string DefaultImageFile="@DefaultImageFile";
                    public static string IsDefault="@IsDefault";
                    public static string ParentID="@ParentID";
                    public static string SiteID="@SiteID";
                }    
            
            public struct Columns{
                    public static string CategoryID="CategoryID";
                    public static string DefaultImageFile="DefaultImageFile";
                    public static string IsDefault="IsDefault";
                    public static string ParentID="ParentID";
                    public static string SiteID="SiteID";
                } 
            public struct ColumnsQualified{
                    public static string CategoryID="[dbo].[Categories].[CategoryID]";
                    public static string DefaultImageFile="[dbo].[Categories].[DefaultImageFile]";
                    public static string IsDefault="[dbo].[Categories].[IsDefault]";
                    public static string ParentID="[dbo].[Categories].[ParentID]";
                    public static string SiteID="[dbo].[Categories].[SiteID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("CategoryID","[dbo].[Categories].[CategoryID]");
                            _qualifiedColumns.Add("DefaultImageFile","[dbo].[Categories].[DefaultImageFile]");
                            _qualifiedColumns.Add("IsDefault","[dbo].[Categories].[IsDefault]");
                            _qualifiedColumns.Add("ParentID","[dbo].[Categories].[ParentID]");
                            _qualifiedColumns.Add("SiteID","[dbo].[Categories].[SiteID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Categories](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Categories]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Categories]");
                return sql;
            }
        }
         

        public static class InventoryStatusTable{
            public const string TABLE_NAME=@"[dbo].[InventoryStatus]";
            public const string COLUMN_LIST=@"[dbo].[InventoryStatus].[Description],[dbo].[InventoryStatus].[InventoryStatusID]";
 
                public static string ReadDescription(DbDataReader rdr){
                string result;
                                result= rdr["Description"].ToString();
                                return result;
            }
                public static int ReadInventoryStatusID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["InventoryStatusID"].ToString(), out result);
                                return result;
            }
        
            
            public struct Parameters{
                    public static string Description="@Description";
                    public static string InventoryStatusID="@InventoryStatusID";
                }    
            
            public struct Columns{
                    public static string Description="Description";
                    public static string InventoryStatusID="InventoryStatusID";
                } 
            public struct ColumnsQualified{
                    public static string Description="[dbo].[InventoryStatus].[Description]";
                    public static string InventoryStatusID="[dbo].[InventoryStatus].[InventoryStatusID]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("Description","[dbo].[InventoryStatus].[Description]");
                            _qualifiedColumns.Add("InventoryStatusID","[dbo].[InventoryStatus].[InventoryStatusID]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[InventoryStatus](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[InventoryStatus]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[InventoryStatus]");
                return sql;
            }
        }
         

        public static class PagesTable{
            public const string TABLE_NAME=@"[dbo].[Pages]";
            public const string COLUMN_LIST=@"[dbo].[Pages].[CreatedBy],[dbo].[Pages].[CreatedOn],[dbo].[Pages].[LanguageCode],[dbo].[Pages].[ListOrder],[dbo].[Pages].[ModifiedBy],[dbo].[Pages].[ModifiedOn],[dbo].[Pages].[PageID],[dbo].[Pages].[PageStatusID],[dbo].[Pages].[Slug],[dbo].[Pages].[Title],[dbo].[Pages].[Url]";
 
                public static string ReadCreatedBy(DbDataReader rdr){
                string result;
                                result= rdr["CreatedBy"].ToString();
                                return result;
            }
                public static DateTime ReadCreatedOn(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["CreatedOn"].ToString(), out result);
                                return result;
            }
                public static string ReadLanguageCode(DbDataReader rdr){
                string result;
                                result= rdr["LanguageCode"].ToString();
                                return result;
            }
                public static int ReadListOrder(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["ListOrder"].ToString(), out result);
                                return result;
            }
                public static string ReadModifiedBy(DbDataReader rdr){
                string result;
                                result= rdr["ModifiedBy"].ToString();
                                return result;
            }
                public static DateTime ReadModifiedOn(DbDataReader rdr){
                DateTime result;
                                DateTime.TryParse(rdr["ModifiedOn"].ToString(), out result);
                                return result;
            }
                public static Guid ReadPageID(DbDataReader rdr){
                Guid result;
                                result=(Guid)rdr["PageID"];
                                return result;
            }
                public static int ReadPageStatusID(DbDataReader rdr){
                int result;
                                int.TryParse(rdr["PageStatusID"].ToString(), out result);
                                return result;
            }
                public static string ReadSlug(DbDataReader rdr){
                string result;
                                result= rdr["Slug"].ToString();
                                return result;
            }
                public static string ReadTitle(DbDataReader rdr){
                string result;
                                result= rdr["Title"].ToString();
                                return result;
            }
                public static string ReadUrl(DbDataReader rdr){
                string result;
                                result= rdr["Url"].ToString();
                                return result;
            }
        
            
            public struct Parameters{
                    public static string CreatedBy="@CreatedBy";
                    public static string CreatedOn="@CreatedOn";
                    public static string LanguageCode="@LanguageCode";
                    public static string ListOrder="@ListOrder";
                    public static string ModifiedBy="@ModifiedBy";
                    public static string ModifiedOn="@ModifiedOn";
                    public static string PageID="@PageID";
                    public static string PageStatusID="@PageStatusID";
                    public static string Slug="@Slug";
                    public static string Title="@Title";
                    public static string Url="@Url";
                }    
            
            public struct Columns{
                    public static string CreatedBy="CreatedBy";
                    public static string CreatedOn="CreatedOn";
                    public static string LanguageCode="LanguageCode";
                    public static string ListOrder="ListOrder";
                    public static string ModifiedBy="ModifiedBy";
                    public static string ModifiedOn="ModifiedOn";
                    public static string PageID="PageID";
                    public static string PageStatusID="PageStatusID";
                    public static string Slug="Slug";
                    public static string Title="Title";
                    public static string Url="Url";
                } 
            public struct ColumnsQualified{
                    public static string CreatedBy="[dbo].[Pages].[CreatedBy]";
                    public static string CreatedOn="[dbo].[Pages].[CreatedOn]";
                    public static string LanguageCode="[dbo].[Pages].[LanguageCode]";
                    public static string ListOrder="[dbo].[Pages].[ListOrder]";
                    public static string ModifiedBy="[dbo].[Pages].[ModifiedBy]";
                    public static string ModifiedOn="[dbo].[Pages].[ModifiedOn]";
                    public static string PageID="[dbo].[Pages].[PageID]";
                    public static string PageStatusID="[dbo].[Pages].[PageStatusID]";
                    public static string Slug="[dbo].[Pages].[Slug]";
                    public static string Title="[dbo].[Pages].[Title]";
                    public static string Url="[dbo].[Pages].[Url]";
                }
                 
            static Dictionary<string, string> _qualifiedColumns;
            static Dictionary<string, string> QualifiedColumns{
                get{
                    if(_qualifiedColumns==null){
                        _qualifiedColumns=new Dictionary<string,string>();
                            _qualifiedColumns.Add("CreatedBy","[dbo].[Pages].[CreatedBy]");
                            _qualifiedColumns.Add("CreatedOn","[dbo].[Pages].[CreatedOn]");
                            _qualifiedColumns.Add("LanguageCode","[dbo].[Pages].[LanguageCode]");
                            _qualifiedColumns.Add("ListOrder","[dbo].[Pages].[ListOrder]");
                            _qualifiedColumns.Add("ModifiedBy","[dbo].[Pages].[ModifiedBy]");
                            _qualifiedColumns.Add("ModifiedOn","[dbo].[Pages].[ModifiedOn]");
                            _qualifiedColumns.Add("PageID","[dbo].[Pages].[PageID]");
                            _qualifiedColumns.Add("PageStatusID","[dbo].[Pages].[PageStatusID]");
                            _qualifiedColumns.Add("Slug","[dbo].[Pages].[Slug]");
                            _qualifiedColumns.Add("Title","[dbo].[Pages].[Title]");
                            _qualifiedColumns.Add("Url","[dbo].[Pages].[Url]");
                        }
                    return _qualifiedColumns;
                }
            }

          
            public static SqlStatement Select(){
                return Select(COLUMN_LIST.Split(new char[]{','},StringSplitOptions.RemoveEmptyEntries));
            }

            public static SqlStatement Select(params string[] columns){
                //for jon galloway
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("SELECT ");
                
                int indexer=1;
                foreach(string s in columns){
                    string qualifiedName=s;
                    if(QualifiedColumns.ContainsKey(s))
                        qualifiedName=QualifiedColumns[s];
                    sb.AppendFormat("{0}",qualifiedName);
                    if(indexer<columns.Length)
                        sb.Append(",");
                    indexer++;
                }
                sb.AppendFormat("\r\nFROM {0} ",TABLE_NAME);
                sb.AppendLine();
                sql.Add(sb.ToString());
                return sql; 

            } 

            public static SqlStatement Insert(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                StringBuilder sb=new StringBuilder();
                sb.Append("INSERT INTO [dbo].[Pages](");
                int indexer=1;
                foreach(string key in settings.Keys){
                    
                    sb.Append(key);
                    if(indexer<settings.Count)
                        sb.Append(",");

                    sql.AddInsertValue(key,settings[key]);
                    indexer++;
                }
                sb.AppendLine(")");
                sql.Add(sb.ToString());
                return sql;
            }
            
           
            public static SqlStatement Update(Dictionary<string,object> settings){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add(string.Format("UPDATE {0} SET ","[dbo].[Pages]"));
                foreach(string key in settings.Keys){
                    sql.AddSetting(key,settings[key]);
                }
                return sql;
            }
            

            public static SqlStatement Delete(){
                var sql=new SqlStatement("KonaConnectionString");
                sql.Add("DELETE FROM [dbo].[Pages]");
                return sql;
            }
        }
        
}